package com.rocket9labs.boxcars;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.view.KeyEvent;

import com.rocket9labs.boxcars.mobile.EbitenView;

import go.Seq;

public class MainActivity extends Activity {
    private static final int backButtonLongPress = 2000; // Milliseconds.
    private long backButtonPressed;
    private Handler handler = new Handler();
    private final Runnable exitRunnable = new Runnable() {
        @Override
        public void run() {
            System.exit(0);
        }
    };

    private EbitenView getEbitenView() {
        return this.findViewById(R.id.ebitenView);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Seq.setContext(getApplicationContext());
        setContentView(R.layout.activity_main);
        getEbitenView().requestFocus();
    }

    @Override
    protected void onPause() {
        handler.postDelayed(exitRunnable, 10 * 60 * 1000);
        getEbitenView().suspendGame();
        super.onPause();
    }

    @Override
    protected void onResume() {
        handler.removeCallbacks(exitRunnable);
        super.onResume();
        getEbitenView().resumeGame();
        getEbitenView().requestFocus();
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            backButtonPressed = System.currentTimeMillis();
            event.startTracking();
            return true;
        }
        boolean handled = super.onKeyDown(keyCode, event);
        getEbitenView().requestFocus();
        return handled;
    }

    @Override
    public boolean onKeyUp(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            if (System.currentTimeMillis() - backButtonPressed >= backButtonLongPress) {
                finishAndRemoveTask();
                System.exit(0);
            } else {
                getEbitenView().requestFocus();
            }
            return true;
        }
        boolean handled = super.onKeyDown(keyCode, event);
        getEbitenView().requestFocus();
        return handled;
    }
}
